#include "hmg.ch"

Function Main
*----------------------------------------*
* (c) Mustafa Lpez  mustalopez@gmail.com
*----------------------------------------*

*----------------------------------* 
  REQUEST DBFCDX , DBFFPT , DBFDBT
  RDDSETDEFAULT( "DBFCDX" )

  REQUEST HB_CODEPAGE_ESWIN     
  HB_SETCODEPAGE("ESWIN")    
 
  REQUEST HB_LANG_ES   
  HB_LANGSELECT("ES")  
*----------------------------------*
  SET CENTURY ON
  SET DATE FRENCH
  SET ESCAPE ON
  SET NAVIGATION EXTENDED
  SET LANGUAGE TO SPANISH 
  SET CODEPAGE TO SPANISH
  SET DELETED ON
  SET DATE FORMAT TO 'dd/mm/yyyy'
  SET BROWSESYNC ON
  SET EXCLUSIVE ON 
*-----------------------------------------------------------------*
    
   DEFINE WINDOW Form_1           ;
      AT 0,0                      ;
      WIDTH 800                   ;
      HEIGHT 610                  ;
      TITLE "Demo: GRID CheckBox" ;
      NOSIZE NOMAXIMIZE           ;
      MAIN                        ;
      ON INIT Opentables()

     @ 15,320 LABEL Label_1 Value "Select Products"  Width  440  Height 032     ; 
                    FONT "Arial" SIZE 17 BOLD ITALIC        

      bColor := { || if ( This.CellRowIndex/2 == int(This.CellRowIndex/2) , {128,128,128} , {192,192,192} ) }
      fColor := { || if ( This.CellRowIndex/2 == int(This.CellRowIndex/2) , BLUE , RED ) }

        SELECT 1
        USE STOCK INDEX STOCK

   DEFINE GRID Grid_1
      ROW     050
      COL     050
      WIDTH   700
      HEIGHT  197 
      HEADERS  {'...', 'C', 'Ref' , 'Producto','Tipo' ,  'Precio'  ,  'CBarras' }
      WIDTHS  { 17, 35,88, 147, 135, 118, 138} 
      VALUE 0  
      IMAGE   { '02.bmp','01.bmp' }
      JUSTIFY { GRID_JTFY_CENTER,GRID_JTFY_LEFT, GRID_JTFY_RIGHT, GRID_JTFY_LEFT , GRID_JTFY_LEFT, GRID_JTFY_RIGHT, GRID_JTFY_LEFT} 
      DYNAMICFORECOLOR { fColor , fColor , fColor, fColor , fColor, fColor, fColor } 
      DYNAMICBACKCOLOR { fColor , bColor , bColor, bColor , bColor, bColor, bColor }  
      BACKCOLOR { 209,238,238 }
      FONTCOLOR { 000,255,020 } 
      ONDBLCLICK SelecDes()
      MULTISELECT .F.
      ROWSOURCE "STOCK"
      COLUMNFIELDS { 'IIF(STOCK->L,1,0)','IIF(STOCK->L,"Si","No")', 'STOCK->REF','STOCK->PRODUCTO','STOCK->TIPO','STOCK->PRECIO','STOCK->CBARRAS' }
      FONTNAME 'Arial'
      FONTSIZE 9
  END GRID

     @ 265,320 LABEL Label_2 Value "Product Selection " Width  440  Height 032 ; 
                     FONT "Arial" SIZE 17 BOLD ITALIC 
             
        SELECT 2   
        USE STOCKP 
        dbgobottom() 

   DEFINE GRID Grid_2
      ROW     305
      COL     050
      WIDTH   700
      HEIGHT  175 
      HEADERS { 'Ref','Producto','Tipo' ,'Precio','CBarras' }
      WIDTHS  {139, 149, 135, 116, 140}
      ITEMS {{""}}
      VALUE 1  
      ROWSOURCE "STOCKP"
      COLUMNFIELDS { 'STOCKP->REF','STOCKP->PRODUCTO','STOCKP->TIPO','STOCKP->PRECIO','STOCKP->CBARRAS' }
      FONTNAME 'Arial'
      FONTSIZE 9
      JUSTIFY { GRID_JTFY_RIGHT , GRID_JTFY_LEFT, GRID_JTFY_LEFT, GRID_JTFY_RIGHT , GRID_JTFY_LEFT}  
      DYNAMICFORECOLOR { fColor, fColor , fColor, fColor, fColor }  
      DYNAMICBACKCOLOR { bColor, bColor , bColor, bColor, bColor }  
      BACKCOLOR { 209,238,238 } 
      FONTCOLOR { 000,255,020 }
   END GRID

      @ 515, 200 BUTTON Button_2  CAPTION "Delete Base" ACTION Deleter()
      @ 515, 365 BUTTON Button_3  CAPTION "Check List"  ACTION GetListSelect()   
      @ 515, 580 BUTTON Button_4  CAPTION "Exit" ACTION Form_1.Release

   END WINDOW

   CENTER WINDOW Form_1
   ACTIVATE WINDOW Form_1

Return

*---------------------------------------------*
Function Opentables()
*---------------------------------------------*
        CLOSE DATABASES
        SELECT 1 
        USE STOCK
        DELETE FOR REF := 0
        PACK
        CLOSE DATABASES

        SELECT 1 
        USE STOCK NEW
        INDEX ON STR(REF) TO STOCK
        CLOSE DATABASES

        SELECT 1 
        USE STOCK INDEX STOCK
       
	SELECT 2   
        USE STOCKP
	
Return

*.............................................*
Function SelecDes()
*---------------------------------------------*

STOCK->(DbGoTo( Form_1.Grid_1.RecNo))

If STOCK->L = .T.
	Replace STOCK->L With .F.	
Else
	Replace STOCK->L With .T.
EndIf

Form_1.Grid_1.Refresh()

Return

*---------------------------------------------*
Function  GetListSelect() 
*---------------------------------------------*
     SET EXCLUSIVE OFF
        CLOSE DATABASES
        USE STOCKP
        APPEND FROM STOCK FIELDS Ref , Producto , Tipo , Precio , CBarras , L FOR L <> .F.    
    SET EXCLUSIVE ON   
        CLOSE DATABASES    
 
       USE STOCK 
       DO WHILE .NOT. EOF()
            REPLACE L WITH .F.
            SKIP
       ENDDO

        CLOSE DATABASES

        SELECT 1 
        USE STOCK  INDEX STOCK

        SELECT 2   
        USE STOCKP

   Form_1.Grid_1.Refresh
   Form_1.Grid_1.value := STOCKP->(Recno())

   Form_1.Grid_2.Refresh
   Form_1.Grid_2.value := STOCKP->(Recno())

return

*---------------------------------------------*
Function Deleter()
*---------------------------------------------*
   CLOSE DATABASES

    SELECT 2
    USE STOCKP
    ZAP
    CLOSE DATABASES

    SELECT 1 
    USE STOCK  INDEX STOCK

    SELECT 2   
    USE STOCKP

   Form_1.Grid_1.Refresh
   Form_1.Grid_1.value := STOCKP->(Recno())

   Form_1.Grid_2.Refresh
   Form_1.Grid_2.value := STOCKP->(Recno())

return


